--
-- ExtendedPlayerTeleportMoneyEvent
--
-- @author  nilBrain
-- @date    07/12/2023

---@class ExtendedPlayerTeleportMoneyEvent
ExtendedPlayerTeleportMoneyEvent = {};
ExtendedPlayerTeleportMoneyEvent_mt = Class(ExtendedPlayerTeleportMoneyEvent, Event);

InitEventClass(ExtendedPlayerTeleportMoneyEvent, "ExtendedPlayerTeleportMoneyEvent");

function ExtendedPlayerTeleportMoneyEvent.emptyNew()
	local self = Event.new(ExtendedPlayerTeleportMoneyEvent_mt);
	return self;
end;

function ExtendedPlayerTeleportMoneyEvent.new(money, farmId)
	local self = ExtendedPlayerTeleportMoneyEvent.emptyNew();
	self.money = money;
    self.farmId = farmId;
	return self;
end;

function ExtendedPlayerTeleportMoneyEvent:readStream(streamId, connection)
	self.money = streamReadUInt16(streamId);
	self.farmId = streamReadUIntN(streamId, 4);
	self:run(connection);
end;

function ExtendedPlayerTeleportMoneyEvent:writeStream(streamId, connection)
    streamWriteUInt16(streamId, self.money);
    streamWriteUIntN(streamId, self.farmId, 4);
end;

function ExtendedPlayerTeleportMoneyEvent:run(connection)
    if not connection:getIsServer() then
		if self.farmId ~= nil then
			g_currentMission.extendedPlayerTeleport:setMoneyChange(self.money, self.farmId);
			print("addMoney run");
		else
			print("no FarmId");
		end;
    else
		print("ExtendedPlayerTeleportMoneyEvent is a client to server only event!");
    end;
end;
